//! @file $RCSfile: config.h,v $
//!
//! Copyright (c) 2006 Atmel.
//!
//! 쌠ʒmɂĂlicense.txţقǂłB
//!
//! ̧قͼь`Ԑݒ`܂݂܂B
//!
//! @version $Revision: 585 $ $Name:  $ $Id: config.h 585 2007-12-11 16:43:17Z rletendu $
//!
//! @todo
//! @bug

#ifndef _CONFIG_H_
#define _CONFIG_H_

//! @defgroup global_config p`Ԑݒ
//! @{
#include "compiler.h"				// ߲ג`
#ifdef __GNUC__
  #include <avr/io.h>					// AVR-GCCײ؎gp
#elif __ICCAVR__
  #include <ioavr.h>					// IAR-AVRײ؎gp
#else
  #error Current COMPILER not supported
#endif


#ifdef  __GNUC__
  #include <avr/power.h>
#endif

//_____ ݸٰ ________________________________________________________________

#include "compiler.h"				//!< ߲ג`
#include "config_motor.h"

//#define MOTOR_CONTROL_CENTER

//! kHzłCPUg
#define FOSC 8000

// TWIMߎ
#define TWI_CMD_MASTER_WRITE		0x10
#define TWI_CMD_MASTER_READ			0x20
#define TWI_CMD_MASTER_WRITE_ALOT	0x30

#define TWI_SLAVE
#define TWI_BAUDRATE				80		// kޯĂłްڰ
#define TWI_SLAVE_ADDRESS			0x10	// TWI]uڽ=0x10

#define BOARD_ID	3	/* 0:m, 1:MC100, 2:MC200, 3:MC301, 4:MC310 */
#define SOFT_ID		1	/* 0:m, 1:BLDCmL, 2:BLDC, 3:BLDCmȂ */
#define REV_ID		1

#define NO_ANSWER	0x99

#define DIRECTION_FORWARD		0	// ]p׸
#define DIRECTION_REVERSE		1	// t]p׸

#define STATE_STOP				0	// ~p׸
#define STATE_RUN				1	// sp׸

#define MOTOR_CONTROL_CENTER	0
#define POTENTIOMETER			1

// ׸ލ\́Bޯ ̂߂ɒI/OԂڼ޽ɑ׸ނu߂ɎgpB
typedef struct {
  U8 current : 8;
  U16 speed : 16;
  U8 state : 1;
  U8 direction : 1;
} motorControlFlags_t;
// -------- Sʌ`ԐݒI ---------------------------------------------------

//! @}

//! Clear_prescaler.
//!
//! ̊֐͓CPU ۯOuؾĂ܂B
//!
//! @param	Ȃ
//!
//! @return	Ȃ
//!
#ifdef  __GNUC__
  #define Clear_prescaler()						(clock_prescale_set(0))
#else
  #define Clear_prescaler()						(Set_cpu_prescaler(0))
#endif

//! Set_prescaler.
//!
//! ̊֐͓CPU ۯOul`Ԑݒ肵܂B
//!
//! @param	x: VOul
//!
//! @return	Ȃ
//!
#ifdef  __GNUC__
  #define Set_cpu_prescaler(x)					(clock_prescale_set(x))
#else
  extern void Set_cpu_prescaler(U8 x);
#endif

#endif // _CONFIG_H_
